/* Actions */
import {
    INIT_SUPPLIER_INVOICES,
    FILTER_SUPPLIER_INVOICES,
    SELECT_SUPPLIER_INVOICES,
    INIT_SUPPLIER_MOVE_LINES
} from '@/constants/actionTypes'
/* Mutations */
import {
    SET_SUPPLIER_INVOICES,
    SET_SELECTED_SUPPLIER_INVOICES,
    SET_FILTER_SUPPLIER_INVOICES,
} from '@/constants/mutationTypes'

const initialState = {
    supplierInvoices: [],
    filterInvoices: [],
    selectedInvoices: null
}
const state = {
    supplierInvoices: initialState.supplierInvoices,
    filterInvoices: initialState.filterInvoices,
    selectedInvoices: initialState.selectedInvoices
}
const getters = {
    /**
     * [supplierInvoices description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    supplierInvoices (state) {
        return state.supplierInvoices
    },
    /**
     * [filterInvoices description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    supplierInvoicesVisibles ( state ) {
        return state.filterInvoices.length ===0 ? state.supplierInvoices :  state.filterInvoices
    },
    /**
     * [selectedInvoices description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    selectedInvoices ( state ) {
        return state.selectedInvoices
    }
}
const mutations = {
    /**
     * [Invoices description]
     * @type {[type]}
     */
    [SET_SUPPLIER_INVOICES] (state, payload ) {
            state.supplierInvoices = payload
    },
    /**
     * [selectedInvoices description]
     * @type {[type]}
     */
    [SET_SELECTED_SUPPLIER_INVOICES] ( state, payload ) {
        state.selectedInvoices= payload
    },
    /**
     * [filterInvoices description]
     * @type {[type]}
     */
    [SET_FILTER_SUPPLIER_INVOICES] ( state, payload ) {
        state.filterInvoices = payload
    }
}
const actions = {
    /**
     * [INIT_SUPPLIER_INVOICES]
     */
    [INIT_SUPPLIER_INVOICES] ({ commit }, payload ) {
        commit(SET_SUPPLIER_INVOICES, payload)
    },
    /**
     * [FILTER_SUPPLIER_INVOICES]
     */
    [FILTER_SUPPLIER_INVOICES] ({ commit }, payload ) {
        commit(SET_FILTER_SUPPLIER_INVOICES, payload)
    },
    /**
     * [SELECT_SUPPLIER_INVOICES]
     */
    [SELECT_SUPPLIER_INVOICES] ({commit, dispatch}, payload) {
        commit(SET_SELECTED_SUPPLIER_INVOICES, payload)

        dispatch(INIT_SUPPLIER_MOVE_LINES, payload.moveLines)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
