/* Actions */
import {
    INIT_SUPPLIER_MOVE_LINES,
    SELECT_SUPPLIER_MOVE_LINES
} from '@/constants/actionTypes'
/* Mutations */
import {
    SET_SUPPLIER_MOVE_LINES,
    SET_SELECTED_SUPPLIER_MOVE_LINES,
    SET_SUPPLIER_LINES_PAYMENTS
} from '@/constants/mutationTypes'

const intialState = {
    supplierMoveLines: [],
    selectdLines: [],
    supplierLinesPayments: [],
    supplierPaymentsTotal: 0
}
const  state = {
    supplierMoveLines: intialState.supplierMoveLines,
    selectdLines: intialState.selectdLines,
    supplierLinesPayments: intialState.supplierLinesPayments,
    supplierPaymentsTotal: intialState.supplierPaymentsTotal
}
const getters = {
    /**
     * [supplierMoveLines description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    supplierMoveLines ( state ) {
        return state.supplierMoveLines
    },
    /**
     * [selectdLines description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    selectdLines ( state ){
        return state.selectdLines
    },
    /**
     * [supplierLinesPayments description]
     * @param  {[type]} state [description]
     * @return {[type]}       [description]
     */
    supplierLinesPayments ( state ) {
        return state.supplierLinesPayments
    },
    supplierPaymentsTotal ( state ) {
        return state.supplierPaymentsTotal
    }
}
const mutations = {
    /**
     * [supplierInvoices description]
     * @type {[type]}
     */
    [SET_SUPPLIER_MOVE_LINES] (state, payload) {
        state.supplierMoveLines = payload
    },
    /**
     * [selectdLines description]
     * @type {[type]}
     */
    [SET_SELECTED_SUPPLIER_MOVE_LINES] ( state, payload) {
        state.selectdLines = payload
    },

    [SET_SUPPLIER_LINES_PAYMENTS] (state, payload) {
        state.supplierLinesPayments = [payload, ...state.supplierLinesPayments]
    }

}
const actions = {
    /**
     * [INIT_SUPPLIER_MOVE_LINES]
     */
    [INIT_SUPPLIER_MOVE_LINES] ({ commit }, payload) {
        commit(SET_SUPPLIER_MOVE_LINES, payload)
    },
    /**
     *  [SELECT_SUPPLIER_MOVE_LINES]
     */
    [SELECT_SUPPLIER_MOVE_LINES] ({ commit }, payload) {
        commit(SET_SELECTED_SUPPLIER_MOVE_LINES, payload)
        commit(SET_SUPPLIER_LINES_PAYMENTS, payload)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
